net.sf.saxon.expr.instruct

## Class Copy

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ParentNodeConstructor
      - - net.sf.saxon.expr.instruct.ElementCreator
        - - net.sf.saxon.expr.instruct.Copy

- All Implemented Interfaces:
    DivisibleInstruction, Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator

      public class Copy
      extends ElementCreator

  Handler for xsl:copy elements in stylesheet.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.ElementCreator

      `inheritNamespaces, onEmpty`

    - ### Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `content, preservingTypes`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Copy(Expression select, boolean selectSpecified, boolean copyNamespaces, boolean inheritNamespaces, SchemaType schemaType, int validation)` Create a shallow copy instruction

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Expression` | `copy()` Copy an expression.
    `Item` | `evaluateItem(XPathContext context)` Evaluate as an expression.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `NamespaceBinding[]` | `getActiveNamespaces()` Callback to get a list of the intrinsic namespaces that need to be generated for the element.
    `NodeName` | `getElementName(XPathContext context, NodeInfo copiedNode)` Callback from ElementCreator when constructing an element
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the Copy expression
    `int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
    `int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
    `ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the result of this instruction.
    `String` | `getNewBaseURI(XPathContext context, NodeInfo copiedNode)` Get the base URI of a copied element node (the base URI is retained in the new copy)
    `Expression` | `getSelectExpression()` Get the expression that selects the node or other item to be copied
    `int` | `getStreamability(int syntacticContext, boolean allowExtensions, List<String> reasons)` Get the "sweep" of this expression as defined in the W3C streamability specifications.
    `CopyAdjunct` | `getStreamingAdjunct()` Get a class that supports streamed evaluation of this expression
    `boolean` | `isCopyNamespaces()` Ask whether namespace nodes are to be copied (in the case of an element)
    `boolean` | `isSelectSpecified()` Ask whether the select attribute was explicitly specified
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `outputNamespaceNodes(XPathContext context, Receiver receiver, NodeName nameCode, NodeInfo copiedNode)` Callback to output namespace nodes for the new element.
    `TailCall` | `processLeavingTail(XPathContext context)` Evaluate the instruction to produce a new element node.
    `void` | `processLeft(Stack<XPathContext> contextStack, Stack<Object> state)` Process the first half of the instruction in streaming mode
    `void` | `processRight(Stack<XPathContext> contextStack, Stack<Object> state)` Process the second half of the instruction in streaming mode
    `protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator

      `checkContentSequence, computeSpecialProperties, getCardinality, getImplementationMethod, getOnEmpty, isInheritNamespaces, iterateEvents, iterateEvents, processLeavingTail, setOnEmpty, suppressValidation`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `addToPathMap, computeCardinality, createsNewNodes, getBaseURI, getContentExpression, getSchemaType, getValidationAction, getValidationOptions, isLazyConstruction, isPreservingTypes, setBaseURI, setContentExpression, setLazyConstruction, setNoNeedToStrip, setValidationAction`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Constructor Detail

    - #### Copy

          public Copy(Expression select,
              boolean selectSpecified,
              boolean copyNamespaces,
              boolean inheritNamespaces,
              SchemaType schemaType,
              int validation)

      Create a shallow copy instruction
      Parameters:
        `select` - selects the node (or other item) to be copied. Never null.
        `selectSpecified` - true if the select attribute of xsl:copy was specified explicitly (in which case the context for evaluating the body will change)
        `copyNamespaces` - true if namespace nodes are to be copied when copying an element
        `inheritNamespaces` - true if child elements are to inherit the namespace nodes of their parent
        `schemaType` - the Schema type against which the content is to be validated
        `validation` - the schema validation mode

  - ### Method Detail

    - #### getSelectExpression

          public Expression getSelectExpression()

      Get the expression that selects the node or other item to be copied
      Returns:
        the select expression. This will be a context item expression if no select attribute was supplied.

    - #### isSelectSpecified

          public boolean isSelectSpecified()

      Ask whether the select attribute was explicitly specified
      Returns:
        true if it was

    - #### isCopyNamespaces

          public boolean isCopyNamespaces()

      Ask whether namespace nodes are to be copied (in the case of an element)
      Returns:
        true if all in-scope namespaces are to be copied

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Overrides:
        `simplify` in class `ElementCreator`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

      Overrides:
        `typeCheck` in class `ElementCreator`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `ParentNodeConstructor`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the dependencies of the expression

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get the immediate sub-expressions of this expression.
      Overrides:
        `iterateSubExpressions` in class `ElementCreator`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressionInfo` in class `ElementCreator`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the item type of the result of this instruction.
      Overrides:
        `getItemType` in class `ElementCreator`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        The context item type.

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `ElementCreator`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Description copied from class: `ParentNodeConstructor`
      Handle promotion offers, that is, non-local tree rewrites.
      Overrides:
        `promoteInst` in class `ParentNodeConstructor`
      Parameters:
        `offer` - The type of rewrite being offered
      Throws:
        `XPathException` - if an error occurs

    - #### getElementName

          public NodeName getElementName(XPathContext context,
                                NodeInfo copiedNode)
                                  throws XPathException

      Callback from ElementCreator when constructing an element
      Specified by:
        `getElementName` in class `ElementCreator`
      Parameters:
        `context` - XPath dynamic evaluation context
        `copiedNode` - the node being copied
      Returns:
        the namecode of the element to be constructed
      Throws:
        `XPathException`

    - #### getNewBaseURI

          public String getNewBaseURI(XPathContext context,
                             NodeInfo copiedNode)

      Get the base URI of a copied element node (the base URI is retained in the new copy)
      Specified by:
        `getNewBaseURI` in class `ElementCreator`
      Parameters:
        `context` - XPath dynamic evaluation context
        `copiedNode` -
      Returns:
        the base URI

    - #### outputNamespaceNodes

          public void outputNamespaceNodes(XPathContext context,
                                  Receiver receiver,
                                  NodeName nameCode,
                                  NodeInfo copiedNode)
                                    throws XPathException

      Callback to output namespace nodes for the new element.
      Specified by:
        `outputNamespaceNodes` in class `ElementCreator`
      Parameters:
        `context` - The execution context
        `receiver` - the Receiver where the namespace nodes are to be written
        `nameCode` -
        `copiedNode` -
      Throws:
        `XPathException`

    - #### getActiveNamespaces

          public NamespaceBinding[] getActiveNamespaces()
                                                 throws XPathException

      Callback to get a list of the intrinsic namespaces that need to be generated for the element. The result is an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.
      Overrides:
        `getActiveNamespaces` in class `ElementCreator`
      Returns:
        the set of namespace bindings.
      Throws:
        `XPathException` - if an error occurs

    - #### processLeavingTail

          public TailCall processLeavingTail(XPathContext context)
                                      throws XPathException

      Description copied from class: `ElementCreator`
      Evaluate the instruction to produce a new element node. This method is typically used when there is a parent element or document in a result tree, to which the new element is added.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Overrides:
        `processLeavingTail` in class `ElementCreator`
      Parameters:
        `context` - XPath dynamic evaluation context
      Returns:
        null (this instruction never returns a tail call)
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      Evaluate as an expression. We rely on the fact that when these instructions are generated by XQuery, there will always be a valueExpression to evaluate the content
      Overrides:
        `evaluateItem` in class `ElementCreator`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### getStreamability

          public int getStreamability(int syntacticContext,
                             boolean allowExtensions,
                             List<String> reasons)

      Description copied from class: `Expression`
      Get the "sweep" of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Overrides:
        `getStreamability` in class `Expression`
      Parameters:
        `syntacticContext` - one of the values `Expression.NAVIGATION_CONTEXT`, `Expression.NODE_VALUE_CONTEXT`, `Expression.INHERITED_CONTEXT`, `Expression.INSPECTION_CONTEXT`
        `allowExtensions` - if false, the definition of "guaranteed streamability" in the W3C specification is used. If true, Saxon extensions are permitted, which make some
        `reasons` - the caller may supply a list, in which case the implementation may add to this list a message explaining why the construct is not streamable, suitable for inclusion in an error message.
      Returns:
        one of the values `Expression.W3C_MOTIONLESS`, `Expression.W3C_CONSUMING`, `Expression.W3C_GROUP_CONSUMING`, `Expression.W3C_FREE_RANGING`

    - #### getStreamingAdjunct

          public CopyAdjunct getStreamingAdjunct()

      Get a class that supports streamed evaluation of this expression
      Overrides:
        `getStreamingAdjunct` in class `ElementCreator`
      Returns:
        the relevant StreamingAdjunct, or null if none is available

    - #### processLeft

          public void processLeft(Stack<XPathContext> contextStack,
                         Stack<Object> state)
                           throws XPathException

      Process the first half of the instruction in streaming mode
      Specified by:
        `processLeft` in interface `DivisibleInstruction`
      Overrides:
        `processLeft` in class `ElementCreator`
      Parameters:
        `contextStack` - the dynamic evaluation context
        `state` - a stack on which the instruction can save state information for use during the corresponding
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### processRight

          public void processRight(Stack<XPathContext> contextStack,
                          Stack<Object> state)
                            throws XPathException

      Process the second half of the instruction in streaming mode
      Specified by:
        `processRight` in interface `DivisibleInstruction`
      Overrides:
        `processRight` in class `ElementCreator`
      Parameters:
        `contextStack` - the stack of XPath context objects for the current execution state
        `state` - a stack on which the instruction can save state information for use during the corresponding
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the Copy expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.